(function ($) {
        
    function applyLayout() {
        var container = document.querySelector('#main-1');
        var msnry = new Masonry(container, {
            // options
            columnWidth: 10,
            itemSelector: '.item'
        });

        msnry.bindResize()
    }

    // Read a page's GET URL variables and return them as an associative array.
    function getUrlVars() {
        var vars = [], hash;
        var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
        for (var i = 0; i < hashes.length; i++) {
            hash = hashes[i].split('=');
            vars.push(hash[0]);
            vars[hash[0]] = hash[1];
        }
        return vars;
    }

	$.fn.scrollPagination = function(options) {
		
		var settings = { 
			nop     : 10, // The number of posts per scroll to be loaded
			offset  : 0, // Initial offset, begins at 0 in this case
			error   : 'No More Posts!', // When the user reaches the end this is the message that is
			                            // displayed. You can change this if you want.
			delay   : 500, // When you scroll down the posts will load after a delayed amount of time.
			               // This is mainly for usability concerns. You can alter this as you see fit
			scroll  : true // The main bit, if set to false posts will not load as the user scrolls. 
			               // but will still load if the user clicks.
		}
		
		// Extend the options so they work with the plugin
		if(options) {
			$.extend(settings, options);
		}
		
		// For each so that we keep chainability.
		return this.each(function() {		
			
			// Some variables 
			$this = $(this);
			$settings = settings;
			var offset = $settings.offset;
			var busy = false; // Checks if the scroll action is happening 
			                  // so we don't run it multiple times
			
			// Custom messages based on settings
			if($settings.scroll == true) $initmessage = '<div style="text-align:center;width:100%;"><img src="images/loading_animation.gif" /></div>';
			else $initmessage = 'Click for more';
			
			// Append custom messages and extra UI
			$this.append('<div class="tiles"></div><div class="loading-bar">' + $initmessage + '</div>');
			
			function getData() {
				
			    var txt = getUrlVars()["txt"];
			    var cname = localStorage.cname;

				// Post data to ajax.php
			    $.post('http://www.homeinspirations.co.za/websrv_search.php?cname=' + cname + '&txt=' + txt, {
						
					action        : 'scrollpagination',
				    number        : $settings.nop,
				    offset        : offset,
					    
				}, function(data) {
						
					// Change loading bar content (it may have been altered)
					$this.find('.loading-bar').html($initmessage);
						
					// If there is no data returned, there are no more posts to be shown. Show error
					if(data == "") { 
						$this.find('.loading-bar').html($settings.error);	
					}
					else {
						
						// Offset increases
					    offset = offset+$settings.nop; 
						    
						// Append the data to the content div
					    $this.find('.tiles').append(data);

						// No longer busy!	
					    busy = false;
                        				    
					    applyLayout();
					}	
						
				});
					
			}	
			
			getData(); // Run function initially
			applyLayout();

			// If scrolling is enabled
			if($settings.scroll == true) {
				// .. and the user is scrolling
				$(window).scroll(function() {
					
					// Check the user is at the bottom of the element
					if($(window).scrollTop() + $(window).height() > $this.height() && !busy) {
						
						// Now we are working, so busy is true
						busy = true;
						
						// Tell the user we're loading posts
						$this.find('.loading-bar').html('<div style="text-align:center;width:100%;"><img src="images/loading_animation.gif" /></div>');
						
						// Run the function to fetch the data inside a delay
						// This is useful if you have content in a footer you
						// want the user to see.
						setTimeout(function() {
							
						    getData();
						    applyLayout();

						}, $settings.delay);
							
					}	
				});
			}
			
			// Also content can be loaded by clicking the loading bar/
			$this.find('.loading-bar').click(function() {
			
				if(busy == false) {
					busy = true;
					getData();
					
				}
			
			});

			applyLayout();
			
		});
	}

})(jQuery);
